<script>
  import {
    Map,
    AttributionControl,
    NavigationControl
  } from "@jailbreak-paris/svelte-mapbox-gl";
  import { tick } from "svelte";
  import { stores } from "@sapper/app";
  import ServiceChannel from "../components/schema_org/ServiceChannel.svelte";
  import SourceControl from "../components/SourceControl.svelte";
  import Sources from "../components/Sources.svelte";
  import Layout from "../components/Layout.svelte";
  import { selection } from "_src/stores.js";
  import { toServiceChannel } from "_src/schema_org.js";
  import { homepage as sourceCodeUrl } from "_src/../package.json";
  import {
    services as serviceInfoMap,
    themes as themeLabelMap
  } from "_src/../static/data/referentiel_services.json";
  const { session } = stores();

  let map;
  $: selection.setMap(map);

  let sources = [
    {
      id: "structures",
      url: "data/structures.geojson",
      type: "geojson",
      visible: true
    }
  ];

  const center = { lng: 3.7792968750030695, lat: 48.935777757603375 };
  const zoom = 5;

  async function resizeMap() {
    await tick();
    map.resize();
  }

  function deselectFeature() {
    $selection = null;
  }

  function zoomToSelectedFeature() {
    map.easeTo({
      center: $selection.feature.geometry.coordinates,
      zoom: map.getMaxZoom() - 1
    });
  }
</script>

<Layout on:resizeHorizontal={resizeMap}>
  <section slot="a" class="m-4">
    <h3>Data sources</h3>
    <SourceControl bind:sources {map} />
  </section>
  <section slot="b" class="m-4">
    {#if $selection && $selection.feature}
      <div class="flex my-1 float-right">
        <button
          class="btn btn-secondary btn-xs mx-1"
          on:click={zoomToSelectedFeature}
          title="Zoomer sur la structure">
          <img src="/heroicons-ui/svg/icon-location.svg" alt="" />
        </button>
        <button
          class="btn btn-secondary btn-xs mx-1"
          on:click={deselectFeature}
          title="Désélectionner la structure">
          <img src="/heroicons-ui/svg/icon-x.svg" alt="X" />
        </button>
      </div>
      <span class="comment">Structure sélectionnée</span>
      <ServiceChannel
        {...toServiceChannel($selection.feature.properties, serviceInfoMap, themeLabelMap)} />
    {:else}
      <div class="comment">Aucune structure sélectionnée</div>
    {/if}
  </section>
  <section slot="c" class="absolute inset-0">
    <Map
      accessToken={$session.mapboxAccessToken}
      hash={true}
      {center}
      {zoom}
      bind:map
      style="mapbox://styles/mapbox/streets-v11"
      attributionControl={false}
      on:click={deselectFeature}>
      <NavigationControl />
      <AttributionControl>
        <a href={sourceCodeUrl} rel="external" target="_blank">Source code</a>
      </AttributionControl>
      <Sources data={sources} />
    </Map>
  </section>
</Layout>
